import chalk from 'chalk';

const packagejson = require('../package.json');

const menus = {
    main: `
${chalk.greenBright('Welcome to the Nodechron Command Line Interface!')}
${chalk.greenBright(`Version ${packagejson.version}`)}
    
${chalk.blueBright('Usage:')} nodechron <command> [options]
${chalk.blueBright('Help:')}  nodechron help <command>
    
${chalk.blueBright('Commands:')}
  episodes      List or open episodes
  moments       List or open moments
  symbols       List or open symbols
  challenges    List or open challenges
  version       Print the version

${chalk.blueBright('Examples:')}
  nodechron episodes list          List all episodes
  nodechron episodes open 1        Open episode 1
  nodechron challenges open 4      Open challenge 4

For more information, visit our site at https://nodechron.com
`,

    episodes: `
    ${chalk.blueBright('episodes list')} ............ list all episodes
    ${chalk.blueBright('episodes open')} <number> ... open episode number in your browser
    
    Example: ${chalk.whiteBright('nodechron episodes open 1')}
        `,
    moments: `
    ${chalk.blueBright('moments list')} ............ list all moments
    ${chalk.blueBright('moments open')} <number> ... open moment number in your browser
    
    Example: ${chalk.whiteBright('nodechron moments open 1')}
    `,
    symbols: `
    ${chalk.blueBright('symbols list')} ............ list all symbols
    ${chalk.blueBright('symbols open')} <number> ... open symbol number in your browser
    
    Example: ${chalk.whiteBright('nodechron symbols open 1')}
    `,
    challenges: `
    ${chalk.blueBright('challenges list')} ............ list all challenges
    ${chalk.blueBright('challenges open')} <number> ... open challenge number in your browser
    
    Example: ${chalk.whiteBright('nodechron challenges open 1')}
        `,
}

export async function help(args) {
    const subCmd = args._[0] === 'help'
        ? args._[1]
        : args._[0]

    // console.log("subCmd: ", subCmd)

    console.log(menus[subCmd] || menus.main)

    // console.log("menus[subCmd]: ", menus[subCmd])
    // console.log("menus.main: ", menus.main)
}