// keyRyilgNya8VSwZ2 -> from a read-only account that FJ created
var Airtable = require('airtable');
var base = new Airtable({ apiKey: 'keyRyilgNya8VSwZ2' }).base('app5VVkW5fFOPP6fU');

const AirtablePlus = require('airtable-plus');


const airtablePlusMoments = new AirtablePlus({
    baseID: 'app5VVkW5fFOPP6fU',
    apiKey: 'keyRyilgNya8VSwZ2',
    tableName: 'Moments',
});
const airtablePlusEpisodes = new AirtablePlus({
    baseID: 'app5VVkW5fFOPP6fU',
    apiKey: 'keyRyilgNya8VSwZ2',
    tableName: 'Episodes',
});


// Episode Number, Episode Name, Episode Description, Episode # of Moments, Episode # of Symbols, Episode Link
export async function getEpisodes() {

    var table = base('Episodes');
    return table
        .select({
            maxRecords: 100,
            view: "Grid view",
            fields: ["episodeNumber", "episodeName", "episodeShortDescription", "episodeMoments", "episodeSymbols", "episodePermalink"]
        })
        .firstPage();

}

export async function getEpisode(episode) {

    var table = base('Episodes');
    return table
        .select({
            maxRecords: 1,
            filterByFormula: `({episodeNumber} = ${episode})`,
            view: "Grid view",
            fields: ["episodeNumber", "episodeName", "episodeShortDescription", "episodePermalink"]
        })
        .firstPage();

}


// Moment Number, Moment Name, Moment Description, # of Symbols, Episodes, Moment Link
// TODO: one could refactor this function in the future to return a promise like explained
// in this link: https://github.com/Airtable/airtable.js/blob/master/README.md#promises
export async function getMoments() {

    var table = base('Moments');
    return table
        .select({
            maxRecords: 100,
            view: "Grid view",
            fields: ["momentName", "momentShortDescription", "Symbols", "momentPermalink", "Episodes"]
        })
        .firstPage();

}


export async function getMoment(momentNumber) {

    var table = base('Moments');
    return table
        .select({
            maxRecords: 1,
            filterByFormula: `({momentNumber} = ${momentNumber})`,
            view: "Grid view",
            fields: ["momentName", "momentShortDescription", "Symbols", "momentPermalink", "Episodes"]
        })
        .firstPage();

}


export async function getRecord(id, tableParam) {

    if (!id) {
        return null;
    }

    let res;
    switch (tableParam) {
        case 'Moments':
            res = await airtablePlusMoments.find(id);
            return res;
            break;
        case 'Episodes':
            res = await airtablePlusEpisodes.find(id);
            return res;
            break;

        default:
            break;
    }
}


// [Name, Description, Moment Name, Episode Name, Link]
// TODO: one could refactor this function in the future to return a promise like explained
// in this link: https://github.com/Airtable/airtable.js/blob/master/README.md#promises
export async function getSymbols() {

    var table = base('Symbols');
    return table
        .select({
            maxRecords: 100,
            view: "Grid view",
            fields: ["symbolNumber", "symbolName", "symbolShortDescription", "symbolParentMoment", "Episodes", "symbolPermalink"]
        })
        .firstPage();

}

export async function getSymbol(symbolNumber) {

    var table = base('Symbols');
    return table
        .select({
            maxRecords: 1,
            filterByFormula: `({symbolNumber} = ${symbolNumber})`,
            view: "Grid view",
            fields: ["symbolName", "symbolShortDescription", "symbolParentMoment", "Episodes", "symbolPermalink"]
        })
        .firstPage();

}

// TODO: one could refactor this function in the future to return a promise like explained
// in this link: https://github.com/Airtable/airtable.js/blob/master/README.md#promises
export async function getChallenges() {

    var table = base('Challenges');
    return table
        .select({
            maxRecords: 100,
            view: "Grid view",
            fields: ["challengeNumber", "challengeName", "challengeDescription", "challengePermalink"]
        })
        .firstPage();

}

export async function getChallenge(ChallengeNumber) {

    var table = base('Challenges');
    return table
        .select({
            maxRecords: 1,
            filterByFormula: `({challengeNumber} = ${ChallengeNumber})`,
            view: "Grid view",
            fields: ["challengeName", "challengeDescription", "challengePermalink"]
        })
        .firstPage();

}
